
class LocationInfo {

  ///水平精确度
  final double? accuracy;

  ///海拔
  final double? altitude;

  ///定位时间
  final String? locationTime;

  ///定位类型
  final int? locationType; //ios仅仅1:GPS定位结果,2:前次定位结果,4:缓存定位结果,5:Wifi定位结果,6:基站定位结果

  ///维度
  final double? latitude;

  ///经度
  final double? longitude;

  ///速度
  final double? speed;

  ///方向角
  final double? bearing;

  ///国家
  final String? country;

  ///省份
  final String? province;

  ///城市
  final String? city;

  ///区县
  final String? district;

  ///街道名称
  final String? street;

  ///门牌号
  final String? streetNumber;

  ///城市编码
  final String? cityCode;

  ///地区码
  final String? adCode;

  ///位置信息
  final String? address;

  ///位置信息 描述
  final String? description;

  LocationInfo({
    this.accuracy = 0,
    this.altitude = 0,
    this.locationTime = "",
    this.locationType = 0,
    this.latitude = 0,
    this.longitude = 0,
    this.speed = 0,
    this.bearing = 0,
    this.country = "",
    this.province = "",
    this.city = "",
    this.district = "",
    this.street = "",
    this.streetNumber = "",
    this.cityCode = "",
    this.adCode = "",
    this.address = "",
    this.description = "",
  });

  factory LocationInfo.fromJson(Map<String, dynamic> json) {
    return LocationInfo(
      accuracy: json['accuracy'] as double?,
      altitude: json['altitude'] as double?,
      locationTime: json['locationTime'] as String?,
      locationType: json['locationType'] as int?,
      latitude: json['latitude'] as double?,
      longitude: json['longitude'] as double?,
      speed: json['speed'] as double?,
      bearing: json['bearing'] as double?,
      country: json['country'] as String?,
      province: json['province'] as String?,
      city: json['city'] as String?,
      district: json['district'] as String?,
      street: json['street'] as String?,
      streetNumber: json['streetNumber'] as String?,
      cityCode: json['cityCode'] as String?,
      adCode: json['adCode'] as String?,
      address: json['address'] as String?,
      description: json['description'] as String?,
    );
  }

  Map<String, dynamic> toJson() {
    return <String, dynamic>{
      'accuracy': accuracy,
      'altitude': altitude,
      'locationTime': locationTime,
      'locationType': locationType,
      'latitude': latitude,
      'longitude': longitude,
      'speed': speed,
      'bearing': bearing,
      'country': country,
      'province': province,
      'city': city,
      'district': district,
      'street': street,
      'streetNumber': streetNumber,
      'cityCode': cityCode,
      'adCode': adCode,
      'address': address,
      'description': description,
    };
  }


}
