
import 'dart:async';
import 'dart:convert';

import 'package:amap_flutter_location/amap_flutter_location.dart';
import 'package:amap_flutter_location/amap_location_option.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/services.dart';

import 'core/location.dart';

typedef LocationCallback = Function( LocationInfo locationInfo );

class XbrGaodeLocation {
  // static const MethodChannel _channel =
  // const MethodChannel('xbr_gaode_location');

  static AMapFlutterLocation? location;
  static AMapFlutterLocation? getLocation(){
    if(location == null) location = AMapFlutterLocation();
    return location;
  }

  static void initKey({required String androidKey,required String iosKey}){
    AMapFlutterLocation.setApiKey(androidKey, iosKey);
  }

  static void updatePrivacy({required bool hasContains,required bool hasShow,required bool hasAgree}){
    AMapFlutterLocation.updatePrivacyShow(hasContains, hasShow);
    AMapFlutterLocation.updatePrivacyAgree(hasAgree);
  }

  static void startLocation({AMapLocationOption? option,LocationCallback? callback}) {
    if (callback == null) return;
    getLocation()?.onLocationChanged().listen((Map<String, Object> result) {
      debugPrint(json.encode(result));
      LocationInfo locationInfo = LocationInfo.fromJson(result);
      callback(locationInfo);
    });
    //默认单次定位
    getLocation()?.setLocationOption(option ?? AMapLocationOption(onceLocation: true));
    getLocation()?.startLocation();
  }

  static void stopLocation() {
    if(location==null) return;
    location?.stopLocation();
  }

  static void destroyLocation() {
    //地图上开启定位（持续定位）必须跟随销毁，否则UI显示时会报错
    if(location==null) return;
    location?.stopLocation();
    location?.destroy();
  }
}
